#define __DELAY_BACKWARD_COMPATIBLE__

#include <avr/io.h>
#define F_CPU  16000000
#include <util/delay.h>

#include <stdlib.h>

void aprindeInchide(){
	PORTD = (1<<PD7);
	_delay_ms(1000);
	PORTD &= ~(1<<PD7);
	_delay_ms(1000);
}

void USART0_Init()
{
	unsigned int baud = 103;
	UBRR0H = (unsigned char)(baud>>8);
    UBRR0L = (unsigned char)baud;

    /* porneste transmitatorul */
    UCSR0B = (1<<TXEN0) | (1<<RXEN0);

    /* seteaza formatul frame-ului: 8 biti de date, 1 biti de stop, fara paritate */
    UCSR0C =  (3<<UCSZ00);
}

char USART0_receive()
{
        while(!(UCSR0A & (1<<RXC0)));

        return UDR0;
}

void reset(){
	PORTA = 0;
}

void driver_init()
{
	reset();
    DDRA |= (15 << PA0);
}

void move_forward()
{
	PORTA = 0;
	//_delay_ms(50);
	PORTA |= (1<<PA0 | 1<<PA2);
}

void move_reverse()
{
	PORTA = 0;
	//_delay_ms(50);
    PORTA |= (1 << PA1 | 1 << PA3);
}

void move_left()
{	
	PORTA = 0;
//	_delay_ms(50);
    PORTA |= (1 << PA0 | 1 << PA3);
}

void move_right()
{
	PORTA = 0;
//	_delay_ms(50);
    PORTA |= (1 << PA1 | 1 << PA2);
}

void stop() /* better not to do this b/c the spring from the
                direction wheels is forced */
{
        PORTA &= ~(15 << PA0);
}


void RandomDrive(){
	int STEPS = 20;
	int i;
	while(1){
		for (i = 0 ; i  < STEPS; i++) {
			if (i / (STEPS/4) == 0) {
				move_forward();
			}
			else if ( i / (STEPS/4) == 1){
				move_reverse();
			}
			else if ( i / (STEPS/4) == 2) {
				move_left();
			}
			else {
				move_right();
			}
			_delay_ms(200);
		}
	}
	reset();

}

/* DOES NOT WORK: RIP */
void BluetoothDrive(){
	 USART0_Init();

    // main loop
    char c;
    while(1)
    {
        c = USART0_receive();
        aprindeInchide();

        if(c=='C'){
        	aprindeInchide();
    		return;
        }
       /* switch(c)
        {

        	//fata
            case 'U':
            	move_forward();		
                break;

            //spate
            case 'D':
        		move_reverse();
                break;

            //stanga
			case 'L':
				move_left();
                break;

            //dreapta
            case 'R':
  				move_right();
                 break;
			
			// reset
			case 'C':
					reset();
                break;
        }*/
    }
}

int main()
{
        driver_init();
		

      //  aprindeInchide();
		RandomDrive();
		//BluetoothDrive();

        return 0;
}
